/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.formatter;

import java.io.IOException;

import net.sf.jmatchparser.template.Formatter;
import net.sf.jmatchparser.util.csv.CSVReader;

import java.io.*;

public class CSVFormatter implements Formatter {

	@Override
	public String getName() {
		return "csv";
	}

	@Override
	public String format(String content, PrintStream debugStream) throws IOException {
		if (content.length() == 0)
			return content;
		CSVReader csvr = new CSVReader(new StringReader(content));
		String[] row;
		StringBuilder result = new StringBuilder();
		while ((row = csvr.read()) != null) {
			for (String cell : row) {
				result.append(":" + cell + "\n");
			}
			result.append("-\n");
		}
		return result.toString();
	}
}
