/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.operation;

import net.sf.jmatchparser.template.engine.CallStackFrame;
import net.sf.jmatchparser.template.engine.ParserState;

public class CallOperation extends Operation {

	private Label templateLabel;
	private Label returnLabel;

	public CallOperation(String templatePosition, Label templateLabel, Label returnLabel) {
		super(templatePosition);
		this.templateLabel = templateLabel;
		this.returnLabel = returnLabel;
	}

	@Override
	public OperationResult execute(ParserState state) {
		state.setCallStack(new CallStackFrame(state.getCallStack(), returnLabel.getDestination()));
		state.setNextInstruction(templateLabel.getDestination());
		return OperationResult.CONTINUE;
	}
}
