/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.operation;

import java.io.IOException;

import net.sf.jmatchparser.template.Formatter;
import net.sf.jmatchparser.template.engine.ParserState;

public class FormatOperation extends SideEffectOperation {

	private Formatter formatter;

	public FormatOperation(String templatePosition, Formatter formatter) {
		super(templatePosition);
		this.formatter = formatter;
	}

	@Override
	public OperationResult executeWithSideEffects(ParserState state) {
		try {
			String rest = state.getRest().toString();
			state.discardCharacters(rest.length());
			state.write(formatter.format(rest, state.getParser().getDebugStream()));
			state.startNextPass();
			return OperationResult.NEXTPASS;
		} catch (IOException ex) {
			throw new RuntimeException("Formatter threw an exception", ex);
		}
	}
}