/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.parameter;

import net.sf.jmatchparser.template.engine.ParserState;

class CallbackFunctionTag extends Tag {

	private final Parameter[] params;

	CallbackFunctionTag(Parameter[] params) {
		this.params = params;
	}

	@Override
	boolean isStatic() {
		return false;
	}

	@Override
	String getString(ParserState state) {
		String cmd = params[0].getString(state);
		int paramcount = params.length - 1;
		for (int i = 1; i < params.length; i++) {
			if (params[i] == null) {
				paramcount = i - 1;
				break;
			}
		}
		String[] args = new String[paramcount];
		for (int i = 0; i < args.length; i++) {
			args[i] = params[i + 1].getString(state);
		}
		if (state.getParser().getCallback(cmd) == null)
			throw new IllegalStateException("Unsupported callback: " + cmd);
		return state.getParser().getCallback(cmd).call(args);
	}
}
