/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.parameter;

import net.sf.jmatchparser.template.engine.ParserState;

class InsertLocalTag extends Tag {

	private final Parameter localName;

	InsertLocalTag(Parameter localName) {
		this.localName = localName;
	}

	@Override
	boolean isStatic() {
		return false;
	}

	@Override
	String getString(ParserState state) {
		String local = state.getLocal(localName.getString(state));
		if (local == null)
			throw new RuntimeException("Undefined local: " + localName.getString(state));
		return local;
	}
}
