/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.parameter;

import java.util.regex.Pattern;

import net.sf.jmatchparser.template.engine.ParserState;

class OptionalTag extends Tag {

	private final Parameter param;

	OptionalTag(Parameter param) {
		this.param = param;
	}

	@Override
	boolean isParsingOnly() {
		return true;
	}

	@Override
	boolean isStatic() {
		return param.isStringStatic();
	}

	@Override
	String getRegex(ParserState state) {
		return "(?:" + Pattern.quote(param.getString(state)) + ")?";
	}

	@Override
	String getString(ParserState state) {
		throw new RuntimeException("This tag can only be used for parsing");
	}
}
