/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.parameter;

import net.sf.jmatchparser.template.engine.ParserState;

class TagParseTag extends ParseTag {

	private final String name;

	TagParseTag(String name, String regex) {
		super(regex);
		this.name = name;
	}

	@Override
	protected void applyMatch(ParserState state, String match) {
		if (name.length() > 0)
			state.appendXmlAction("<>", name);
		state.appendXmlAction("T", match);
		if (name.length() > 0)
			state.appendXmlAction("/>");
	}

}
