/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.template.command.plain;

import net.sf.jmatchparser.template.engine.operation.CallOperation;
import net.sf.jmatchparser.template.engine.operation.Label;
import net.sf.jmatchparser.template.engine.template.MatchTemplateImpl;
import net.sf.jmatchparser.template.engine.template.PlainBlockCommandState;

public class CallTemplateCommand extends Command {

	@Override
	public PlainBlockCommandState parse(MatchTemplateImpl template, String parameters) {
		Label returnLabel = new Label();
		Label templateLabel = template.getDefLabels().get(parameters);
		if (templateLabel == null)
			throw new RuntimeException("No DEFTEMPLATE named " + parameters + " found");
		template.appendOperation(new CallOperation(template.getCurrentTemplatePosition(), templateLabel, returnLabel));
		returnLabel.setDestinationToNextCommand(template);
		return null;
	}
}
