/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.template.command.plain;

import net.sf.jmatchparser.template.ChainedFormatter;
import net.sf.jmatchparser.template.Formatter;
import net.sf.jmatchparser.template.engine.operation.FormatOperation;
import net.sf.jmatchparser.template.engine.template.PlainBlockCommandState;
import net.sf.jmatchparser.template.engine.template.MatchTemplateImpl;

public class FormatCommand extends Command {

	@Override
	public PlainBlockCommandState parse(MatchTemplateImpl template, String parameters) {
		String[] formatterNames = parameters.split(",");
		Formatter[] formatters = new Formatter[formatterNames.length];
		for (int i = 0; i < formatters.length; i++) {
			formatters[i] = template.getFormatter(formatterNames[i]);
			if (formatters[i] == null)
				throw new RuntimeException("Unsupported formatter: " + formatterNames[i]);
		}
		template.appendOperation(new FormatOperation(template.getCurrentTemplatePosition(), new ChainedFormatter("", formatters)));
		return null;
	}

}
