/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.template.command.plain;

import net.sf.jmatchparser.template.engine.operation.MatchOperation;
import net.sf.jmatchparser.template.engine.parameter.Parameter;
import net.sf.jmatchparser.template.engine.template.MatchTemplateImpl;
import net.sf.jmatchparser.template.engine.template.PlainBlockCommandState;

public class MatchCommand extends Command {

	private final boolean checkOnly;
	private final boolean negateCheck;
	private final boolean wholeLine;

	public MatchCommand(boolean checkOnly, boolean negateCheck, boolean wholeLine) {
		this.checkOnly = checkOnly;
		this.negateCheck = negateCheck;
		this.wholeLine = wholeLine;
		if (negateCheck && !checkOnly)
			throw new RuntimeException();
	}

	@Override
	public PlainBlockCommandState parse(MatchTemplateImpl template, String parameters) {
		template.appendOperation(new MatchOperation(template.getCurrentTemplatePosition(),
				Parameter.parseParameter(parameters, template.getSpecialTags()),
				checkOnly, negateCheck, wholeLine));
		return null;
	}

}
