/*
 * Copyright (c) 2006 - 2011 Michael Schierl
 * All rights reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.jmatchparser.template.engine.template.command.plain;

import net.sf.jmatchparser.template.engine.operation.XMLBlockEndOperation;
import net.sf.jmatchparser.template.engine.operation.XMLBlockStartOperation;
import net.sf.jmatchparser.template.engine.parameter.Parameter;
import net.sf.jmatchparser.template.engine.template.PlainBlockCommandState;
import net.sf.jmatchparser.template.engine.template.MatchTemplateImpl;

public class XMLBlockCommand extends Command {

	@Override
	public PlainBlockCommandState parse(MatchTemplateImpl template, String parameters) {
		Parameter param = Parameter.parseParameter(parameters, template.getSpecialTags());
		template.appendOperation(new XMLBlockStartOperation(template.getCurrentTemplatePosition(), param));
		return new XMLBlockCommandState(template);
	}

	private class XMLBlockCommandState extends PlainBlockCommandState {

		public XMLBlockCommandState(MatchTemplateImpl template) {
			super(template);
		}

		@Override
		public boolean canParse(String commandName) {
			return commandName.equals("endblock");
		}

		@Override
		public PlainBlockCommandState parseCommand(MatchTemplateImpl template,
				String commandName, String parameters) {
			template.appendOperation(new XMLBlockEndOperation(template.getCurrentTemplatePosition()));
			return null;
		}
	}
}
